
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>JAVA 面向对象之方法详解 / 憋错料</title>

    <meta name="description" content="JAVA 面向对象之方法详解 本页面更新日期: 2016年07月18日 前言 方法是类或对象 的行为特征的抽象. 方法是类或对象最重要的组成部分. 所有的方法都必需定义在类里. 方法不能独立存在. 方法在逻辑上要么属于类, 要么属于对象. 方法的所属性 一旦将一个方法定义在某个类的类体内. 如果这个方法使用了static修饰符,则这个方法属于这个类. 否则这个方法属于这个类的实例. Java语言是静态的. 一个类定义完成后,只要不再重新编译这个类文件,该类和该类的对象所拥有的方法是固定的,永远都不会改变. 执行方法时必需使用">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">JAVA 面向对象之方法详解</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>本页面更新日期: 2016年07月18日</p>
<h2>前言</h2>
<blockquote><p>方法是类或对象 的行为特征的抽象.</p>
<p>方法是类或对象最重要的组成部分.</p>
<p>所有的方法都必需定义在类里.</p>
<p>方法不能独立存在.</p>
<p>方法在逻辑上要么属于类, 要么属于对象.</p></blockquote>
<h2>方法的所属性</h2>
<blockquote><p>一旦将一个方法定义在某个类的类体内.</p>
<p>如果这个方法使用了static修饰符,则这个方法属于这个类.</p>
<p>否则这个方法属于这个类的实例.</p>
<p>Java语言是静态的.</p>
<p>一个类定义完成后,只要不再重新编译这个类文件,该类和该类的对象所拥有的方法是固定的,永远都不会改变.</p>
<p>执行方法时必需使用类或对象来作为调用者.</p>
<p>即所有方法都必需使用 类.方法 或 对象.方法 的形式来调用.</p>
<p>这里可能有个问题: 同一个类里不同方法之间相互调用时,</p>
<p>不就可以直接调用嘛?</p>
<p>这里需要指出:</p>
<p>同一个类的一个方法调用另一个方法时,如果被调用方法是普通方法,则默认使用 this 作为调用者;</p>
<p>如果被调方法是静态方法,则默认使用类作为调用者.</p>
<p>也就是说,表面上看起来某些方法可以被独立执行, 但实际上还是使用 this 或者 类 来作为调用者.</p>
<p>永远不要把方法当成独立存在的实体.</p>
<p>正如现实世界由类和对象组成,而方法只能作为类和对象的附属.</p>
<p>Java语言里方法的所属性主要体现在如下几个方面:</p></blockquote>
<ul>
<li>方法不能独立定义, 方法只能在类体里定义.</li>
<li>从逻辑意义上来看,方法要么属于该类本身,要么属于该类的一个对象.</li>
<li>永远不能独立执行方法,执行方法必需使用类或对象作为调用者.</li>
</ul>
<blockquote><p>使用 static 修饰符的方法属于这个类本身.</p>
<p>使用 static 修饰付的方法 既可以使用类作为调用者来调用.</p>
<p>也可以使用对象作为调用者来调用.</p>
<p>但需要指出的是, 因为使用 static 修饰的方法还是属于这个类的.</p>
<p>因此使用该类的任何对象来调用这个方法时将会得到相同的执行结果.</p>
<p>这是由于底层依然是使用这些实例所属的类作为调用者.</p>
<p>虽然Java允许你写的时候,拿该类的实例来调用 static 修饰的类方法.</p>
<p>但是你要明白其中的运行机制.</p>
<p>所以建议你自己写程序的时候, 尽量不要混着用.</p>
<p>用实例来调用实例的方法, 用类来调用 static 修饰的类方法.</p>
<p>没有 static 修饰符的方法则属于该类的对象,不属于这个类本身.</p>
<p>因此没有 static 修饰符的方法只能使用对象作为调用者来调用.</p>
<p>不能使用类作为调用者来调用.</p>
<p>使用不同对象作为调用者来调用同一个普通方法可能会得到不同的结果.</p>
<p>看到这里, 你应该明白, 使用 static 和 不使用 static 修饰的方法是有区别的.</p>
<p>以后我们写程序的时候, 你慢慢就能体会到其中的奥妙.</p></blockquote>
<h2>方法的参数传递机制</h2>
<blockquote><p>如果声明方法时包含了形参声明.</p>
<p>则调用方法时必需给这些形参指定参数值.</p>
<p>调用方法时实际传给形参的参数值也被称为实参.</p>
<p>那么,Java的实参值是如何传入方法的呢?</p>
<p>这是由Java方法的参数传递机制来控制的.</p>
<p>Java里方法参数传递方式只有一种 – 值传递.</p>
<p>所谓值传递,就是将实际参数值的副本(复制品)传入方法内.</p>
<p>而参数本身不会受到任何影响.</p>
<p>小插曲:</p>
<p>Java里参数传递类似于&lt;西游记&gt;里的孙悟空.</p>
<p>孙悟空复制了一个假孙悟空,这个假孙悟空具有和孙悟空相同的能力.</p>
<p>可除妖或被砍头.</p>
<p>但不管这个假孙悟空遇到什么事,真孙悟空不会受到任何影响.</p>
<p>与此类似,传入方法的是实际参数的复制品.</p>
<p>不管方法中对这个复制品如何操作,实际参数值本身不会受到任何影响.</p>
<p>写个程序演示一下方法参数传递的效果:</p></blockquote>
<pre><code>public class PrimitiveTransferTest
{
  public static void swap(int a, int b)
  {
    //下面三行代码实现 a, b变量的值交换
    //定义一个临时变量来保存 a 变量的值
    int tmp = a;
    //把 b 的值赋给 a
    a = b;
    //把临时变量 tmp 的值赋给 a
    b = tmp;
    System.out.println("swap方法里, a 的值是:" + a + "; b 的值是:" + b);
  }

  public static void main(String[] args)
  {
    int a = 6;
    int b = 9;
    PrimitiveTransferTest.swap(a, b);
    System.out.println("交换结束后, 变量 a 的值是:" + a + "; 变量 b 的值是:" + b);
  }
}
</code></pre>
<blockquote><p>运行之后, 你可以结果中得知.</p>
<p>swap() 方法里的 a 的值是 9 ;  b 的值是 6</p>
<p>交换结束后, 变量 a 的值依然是 6; 变量 b 的值依然是 9</p>
<p>可以得出以下结论:</p>
<p>main() 方法里的变量 a 和 b</p>
<p>并不是 swap() 方法里的 a 和 b</p>
<p>正如前面所说, swap() 方法里的 a 和 b 只是 main() 方法里的变量 a 和 b 的复制品.</p>
<p>下面我画个图演示一下其执行过程.</p>
<p>Java程序总是从 main() 方法开始执行, main()方法开始定义了 a / b 两个局部变量.</p>
<p>两个变量在内存中的存储示意图如下图所示.</p></blockquote>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA3MTgxNjEzNTYyMjg=.jpg"></p>
<blockquote><p>当程序执行 swap() 方法时, 系统进入 swap()方法, 并将 main() 方法中的 a / b 变量作为参数值传入 swap() 方法.</p>
<p>传入 swap() 方法的只是 a / b 的副本, 而不是 a / b 本身.</p>
<p>进入 swap() 方法后系统产生了 4 个变量, 这 4 个变量在内存中的存储示意图如下:</p></blockquote>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA3MTgxNjIwMzc0NTY=.jpg"></p>
<blockquote><p>系统分别为 main() 方法 和 swap() 方法分配了两块栈区.</p>
<p>用于保存 main() 方法 和 swap() 方法的局部变量.</p>
<p>main() 方法中的 a / b 变量作为参数值传入 swap() 方法.</p>
<p>实际上是在 swap() 方法的栈区中 重新产生了两个变量 a / b.</p>
<p>并将 main() 方法的栈区中 a / b 变量的值分别赋给 swap() 方法的栈区中的 a / b 参数.</p>
<p>此时, 系统存在两个 a 变量 / 两个 b 变量.</p>
<p>只是存放在不同方法的不同栈区中.</p>
<p>程序在 swap() 方法中交换 a / b 两个变量的值.</p>
<p>交换结束后, 我们看到 a 的值是 9 / b 的值是 6</p>
<p>此时内存中的存储示意图如下图所示:</p></blockquote>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA3MTgxNjI4MTUwNjQ=.jpg"></p>
<blockquote><p>我们可以看到, 在所有示意图中, main() 方法栈区中的 a / b 的值并未有任何改变.</p>
<p>程序改变的只是 swap() 方法栈区中的 a 和 b.</p>
<p>这就是值传递的实质:</p>
<p>当系统开始执行方法时, 系统为形参执行初始化.</p>
<p>就是把实参变量的值赋给方法的形参变量.</p>
<p>方法里操作的并不是实际的实参变量.</p>
<p>上面你看到的是 基本类型的参数传递.</p>
<p>Java对于引用类型的参数传递, 一样采用的是值传递方式.</p>
<p>但许多小学生可能对引用类型的参数传递产生误会.</p>
<p>下面程序示范了引用类型的参数传递效果.</p></blockquote>
<pre><code>class DataWrap
{
  int a;
  int b;
}

public class ReferenceTransferTest
{
  public static void swap(DataWrap dw)
  {
    //下面三行代码实现 dw 的 a / b 两个成员变量的值交换
    //定义一个临时变量来保存 dw 对象的 a 成员变量的值
    int tmp = dw.a;
    //把 dw 对象的 b 成员变量的值赋给 a 成员变量
    dw.a = dw.b;
    //把临时变量 tmp 的值赋给 dw 对象的 b 成员变量
    dw.b = tmp;
    //输出看看结果
    System.out.println("swap 方法里, a 成员变量的值是:" + dw.a + "; b 成员变量的值是:" + dw.b);
  }
  public static void main(String[] args)
  {
    DataWrap dw = new DataWrap();
    dw.a = 6;
    dw.b = 9;
    swap(dw);
    System.out.println("交换结束后, a 成员变量的值是:" + dw.a + "; b 成员变量的值是:" + dw.b);
  }
}
</code></pre>
<blockquote><p>从运行结果来看, 在 swap() 方法里, a / b 两个成员变量的值被交换成功.</p>
<p>不仅如此, 当 swap() 方法执行结束后, main() 方法里 a / b 两个成员变量的值也被交换了.</p>
<p>这很容易造成一种错觉:</p>
<p>调用 swap() 方法时, 传入 swap() 方法的就是 dw 对象本身, 而不是它的复制品.</p>
<p>但!!! 这仅仅是一种错觉.</p>
<p>下面还是结合示意图来说明程序的执行过程.</p>
<p>程序从 main() 方法开始执行, main() 方法开始创建了一个 DataWrap 对象,</p>
<p>并定义了一个 dw 引用变量来指向 DataWrap 对象, 这是一个与基本类型不同的地方.</p>
<p>创建一个对象时, 系统内存中由两个东西:</p>
<p>堆内存中保存了对象本身.</p>
<p>栈内存中保存了引用该对象的引用变量.</p>
<p>接着程序通过引用来操作 DataWrap 对象.</p>
<p>把该对象的 a / b 两个成员变量分别赋值为 6 和 9</p>
<p>此时系统内存中的存储示意图如下:</p></blockquote>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA3MTgxNzA0NTY1NjQ=.jpg"></p>
<blockquote><p>接下来, main() 方法中开始调用 swap() 方法.</p>
<p>系统会分别为 main() 和 swap() 开辟出两个栈区.</p>
<p>用于存放 main() 和 swap() 方法的局部变量.</p>
<p>调用 swap() 方法时, dw 变量作为实参传入 swap() 方法.</p>
<p>同样采用的是值传递方式:</p>
<p>把 main() 方法里的 dw 变量的值 赋给 swap() 方法里的 dw 形参.</p>
<p>从而完成 swap() 方法的 dw 形参的初始化.</p>
<p>值得注意的是, main() 方法中的 dw 是一个引用.</p>
<p>它保存了 DataWrap 对象的地址.</p>
<p>当把 dw 的值赋给 swap() 方法的 dw 形参后.</p>
<p>即让 swap() 方法的 dw 形参也保存这个地址值.</p>
<p>即也会引用到堆内存中的DataWrap对象.</p>
<p>下图演示 dw 传入 swap() 方法后的存储示意图:</p></blockquote>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA3MTgxNzEyMjg3NzA=.jpg"></p>
<blockquote><p>可以由图看出, 这种参数传递方式 是不折不扣 的值传递方式.</p>
<p>系统一样复制了 dw 的副本传入 swap() 方法.</p>
<p>但关键在于 dw 只是一个引用变量, 所以系统复制了 dw 变量, 但并未复制 DataWrap 对象.</p>
<p>当程序在 swap() 方法中操作 dw 形参时, 由于 dw 只是一个引用变量.</p>
<p>所以实际操作的还是堆内存中的DataWrap对象.</p>
<p>此时, 不管是操作 main() 方法里的 dw() 变量, 还是操作 swap() 方法里的 dw() 参数.</p>
<p>其实都是操作它们共同引用的 DataWrap 对象.</p>
<p>因为它们操作的都是同一个对象</p>
<p>所以在 swap() 方法中交换 dw 参数所引用的 DataWrap 对象的 a / b 两个成员变量的值后.</p>
<p>可以看到 main() 方法中 dw 变量所引用的 DataWrap 对象的 a / b 两个成员变量的值也被交换了.</p>
<p>为了更好的证明 main() 方法中的 dw 和 swap() 方法中的 dw 是两个变量.</p>
<p>在 swap() 方法的最后一行增加如下代码:</p></blockquote>
<pre><code>//把 dw 赋值为 null , 让它不再指向任何有效地址
dw = null;</code></pre>
<blockquote><p>执行上面代码的结果是 swap() 方法中的 dw 变量不再指向任何有效内存.</p>
<p>程序其它地方不做任何修改.</p>
<p>main() 方法调用了 swap() 方法后, 再次访问 dw 变量的 a / b 两个成员变量, 依然可以输出 9 和 6.</p>
<p>可见 main() 方法中的 dw 变量没有受到任何影响.</p>
<p>实际上, 当 swap() 方法中增加 dw=null 代码后, 内存中的存储示意图如下:</p></blockquote>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA3MTgxNzI0MjYxODE=.jpg"></p>
<blockquote><p>从上图可以看到, 把 swap() 方法中的 dw 赋值为 null 后.</p>
<p>swap() 方法中 失去了 DataWrap 的引用, 不可以再访问堆内存中的 DataWrap 对象.</p>
<p>但 main() 方法中的 dw 变量不受任何影响, 依然引用着 DataWrap 对象.</p>
<p>所以依然可以输出 DataWrap 对象的 a / b 成员变量的值.</p></blockquote>
<h2>形参个数可变的方法</h2>
<blockquote><p>Java允许定义形参个数可变的参数.</p>
<p>从而允许为方法指定数量不确定的形参.</p>
<p>如果在定义方法时, 在最后一个形参的类型后增加三个点 …</p>
<p>则表明该形参可以接受多个参数值.</p>
<p>多个参数值将被当成数组传入.</p>
<p>下面我定义一个形参个数可变的方法:</p></blockquote>
<pre><code>
public class Varargs
{
  //定义了形参个数可变的方法
  public static void test(int a, String... books)
  {
    //boos 被当成数组处理
    for(String tmp : books)
    {
      System.out.println(tmp);
    }
    //输出整数变量 a 的值
    System.out.println(a);
  }
  public static void main(String[] args)
  {
    //调用 test 方法
    test(5, "我是谁?", "我是比克大魔王", "哈哈哈!", "你真逗比!");
  }
}
</code></pre>
<blockquote><p>从上面程序的运行结果可以看出.</p>
<p>调用 test() 方法时, books 参数可以传入多个字符串作为参数值.</p>
<p>从 test() 的方法体代码来看, 形参个数可变的参数本质就是一个数组参数.</p>
<p>小提示: 下面两个写法效果是一样的.</p></blockquote>
<pre><code>//以可变个数形参来定义方法
public static void test(int a, String... books);
//采用数组形参来定义方法
public static void test(int a, String[] books);</code></pre>
<blockquote><p>这两种形式都包含了一个名为 books 的数组形参.</p>
<p>不过在使用它们时有区别, 对于以可变形参的形式定义的方法.</p>
<p>调用时写法更加简洁.如下面代码所示:</p></blockquote>
<pre><code>test(5, "我是谁?", "我是比克大魔王", "哈哈哈!", "你真逗比!");</code></pre>
<blockquote><p>但如果采用数组参数来定义方法的话, 就要这样写:</p></blockquote>
<pre><code>test(5, new String[]{"我是谁?", "我是比克大魔王", "哈哈哈!", "你真逗比!"});</code></pre>
<blockquote><p>对比之后, 明显第一种形式更加简洁.</p>
<p>实际上, 即使你采用 形参个数可变的形式来定义方法, 调用该方法时也一样可以为其传入一个数组.</p>
<p>最后需要指出的是:</p>
<p>数组形式的形参可以处于形参列表的任意位置.</p>
<p>但个数可变的形参只能只能处于形参列表的最后.</p>
<p>也就是说, 一个方法中最多只能有一个长度可变的形参.</p>
<p>知道真相的你是不是眼泪掉下来, 看来不是所有情景都适合使用更简洁的 长度可变的形参.</p></blockquote>
<h2>递归方法</h2>
<blockquote><p>一个方法体内调用它自身,被称为方法递归.</p>
<p>方法递归包含了隐式的循环,它会重复执行某段代码,但这种重复执行无需循环控制.</p>
<p>例如有如下数学题.</p>
<p>已知有一个数列: (<a href="http://baike.baidu.com/link?url=3QjFYelxBhU2Q3Mulh4IvbxwtRnP0Ekm_VPrcEYItF4K15qrsWsDVdxpTc4G_lWvUZirqL7F_Ak_-P4t7xZkwa" rel="external nofollow noreferrer">数列是什么鬼?</a>)</p>
<p>f(0) = 1, f(1) = 4, f(n+2) = 2 * f (n+1) + f(n)</p>
<p>其中 n 是大于 0 的整数, 求 f(10) 的值.</p>
<p>这个问题可以用 递归 来求得.</p>
<p>下面程序将定义一个 fn 方法, 用于计算 f(10) 的值.</p></blockquote>
<pre><code>public class Recursive
{
  public static int fn(int n)
  {
    if(n == 0)
    {
      return 1;
    }
    else if(n == 1)
    {
      return 4;
    }
    else
    {
      //方法中调用它自身,就是方法递归
      return 2 * fn(n - 1) + fn(n - 2);
    }
  }
  public static void main(String[] args)
  {
    //输出 fn(10) 的结果
    System.out.println(fn(10));
  }
}
</code></pre>
<blockquote><p>对于 fn(10) 而言.</p>
<p>即等于 2 * fn(9) + fn(8), 其中fn(9)又等于 2 * fn(8) + fn(7) …… 以此类推.</p>
<p>最终会计算到 fn(2) 等于 2 * fn(1) + fn(0) 即 fn(2) 是可计算的.</p>
<p>然后一路反算回去, 就可以最终得到 fn(10) 的值.</p>
<p>仔细看上面递归的过程, 当一个方法不断地调用它本身时, 必需在某个时刻方法的返回值是确定的.</p>
<p>即不再调用它本身, 否则这种递归就变成了无穷递归, 类似与死循环.</p>
<p>因此定义递归方法时有一条最重要的规则: 递归一定要向已知方向递归.</p>
<p>递归是非常有用的.</p>
<p>例如希望遍历某个路径下的所有文件.</p>
<p>但这个路径下文件夹的深度是未知的.</p>
<p>那么就可以使用递归来实现这个需求.</p>
<p>系统可以定义一个方法, 该方法接受一个文件路径作为参数.</p>
<p>该方法可遍历当前路径下的所有文件和文件路径.</p>
<p>该方法中再次调用该方法本身来处理该路径下的所有文件路径.</p>
<p>总之, 只要一个方法的方法体实现中再次调用了方法本身, 就是递归方法.</p>
<p>递归一定要向已知方向递归.</p></blockquote>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-07 15:09:20 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>JAVA 面向对象之方法详解的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGkqVbM.html" rel="bookmark">Java面向对象之异常详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目录 Java面向对象之异常[一] Java面向对象之异常[二] 捕获异常的规则 访问异常信息 异常对方法重写的影响 finally详解 Java面向对象之异常[一] Java面向对象之异常[二] 往期回顾:上一篇我们大致总结了异常的继承体系,说明了Exception和Error两个大类都继承于顶级父类Throwable,又谈到编译时异常与运行时异常的区别,谈到异常的处理方式,以及处理方式中关于捕获方式的几种类型. 本篇承上启下,将从异常的其余部分进行总结,但是毕竟现在处于初学阶段,未必能够体会			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xQ8KB3.html" rel="bookmark">&lbrack;java&rsqb; java 线程join方法详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				join方法的作用是使所属线程对象正常执行run方法,而对当前线程无限期阻塞,直到所属线程销毁后再执行当前线程的逻辑. 一.先看普通的无join方法NoJoin.java public class NoJoin extends Thread{ @Override public void run() { try { long count = (long)(Math.random()*100); System.out.println(count); Thread.sleep(count); } ca			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWYGxa3.html" rel="bookmark">Java学习系列&lpar;二十三&rpar;Java面向对象之内部类详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.前言 内部类也称寄生类,就是把一个类放在类里面(即内部类的上一级程序单元是类)定义,将其作为外部类的成员.内部类主要用几种定义形式:静态(static)内部类,非静态内部类,匿名内部类(也就是没有名字的寄生类).内部类的好处就是内部类可以直接外部类的(包括私有)成员,反之不能.下面我们通过一些实例来详细讲解一下Java中内部类的使用及几种定义形式的相互调用. 二.实例说明 (1)匿名内部类:当程序创建匿名内部类时,会立即创建匿名内部类(实现类)的实例. interface IBreathe			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02Z6dE0.html" rel="bookmark">Java学习系列&lpar;二十&rpar;Java面向对象之反射详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处:http://blog.csdn.net/lhy_ycu/article/details/45289391 前言 今天讲讲Java中的反射.我们常见的反射多用于JDBC中的加载驱动程序Class.forName(&quot;com.mysql.jdbc.Driver&quot;);.Struts的MVC.Hibernate中的ORM.Spring中的IOC还有一些其他框架等等.那它有什么好处呢?它的好处就是能够动态的创建对象和编译且能够访问某个类中的所有(包括私有)属性方法及对象的属性方法			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kN76bM.html" rel="bookmark">Java学习系列&lpar;二十一&rpar;Java面向对象之注解详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处:http://blog.csdn.net/lhy_ycu/article/details/45295947 一.前言 Java中的注解Annotation运用到很多方面,比如之前讲的单元测试中的@Test.Spring.SpringMVC还有其他框架等等.Java本身自带的注解也有一些,比如:@Override(子类要重写/覆写父类的对应方法).@Deprecated(表示方法不建议被使用).@SuppressWarnings(抑制警告)等等.当然,我们也可以自定义一些自己需要的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6ynd54.html" rel="bookmark">Java学习系列&lpar;二十二&rpar;Java面向对象之枚举详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处:http://blog.csdn.net/lhy_ycu/article/details/45332565 一.前言 今天我们来讲讲枚举,希望通过这篇博客大家能对枚举有个更全面的了解.枚举是一种实例(大写)数固定的类(不能再创建实例),多用于确定的状态数(如:鼠标上下左右.IM消息已读未读).类型数(如:系统.聊天.添加好友消息,我的他的).模式数(回复.评论模式,刷选.全部模式)等等.枚举和类一样,同样有抽象类.可以实现接口.可含内部类.初始化块,值得注意的是:枚举的构造器无论			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0djZWZ4.html" rel="bookmark">java基础-main方法详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				/* 主函数(主方法) * 1.public (访问修饰符,公共的)代表该类或者该函数访问权限是最大的 * 2.static 代表主函数随着类的加载就已经粗在了 * 3.void 代表主函数没有具体的返回值 * 4.main main不是一个java关键字,他是一个特殊的单词,他能够被jvm(java虚拟机)所识别 * 5.string[] args函数的参数是一个字符串数组,该数组的元素是字符串 * */ public class A6_38 { public static void main			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MP2zO13.html" rel="bookmark">java Class&period;forName&lpar;&rpar; 方法详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文地址: http://blog.csdn.net/kaiwii/article/details/7405761 主要功能 Class.forName(xxx.xx.xx)返回的是一个类 Class.forName(xxx.xx.xx)的作用是要求JVM查找并加载指定的类, 也就是说JVM会执行该类的静态代码段 下面,通过解答以下三个问题的来详细讲解下Class.forName()的用法. 一.什么时候用Class.forName()? 先来个热身,给你一个字符串变量,它代表一个类的包名和类名			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49Ax8A4.html" rel="bookmark">Java ArrayList排序方法详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				由于其功能性和灵活性,ArrayList是 Java 集合框架中使用最为普遍的集合类之一.ArrayList 是一种 List 实现,它的内部用一个动态数组来存储元素,因此 ArrayList 能够在添加和移除元素的时候进行动态的扩展和缩减.你可能已经使用过 ArrayList,因此我将略过基础部分.如果你对 ArrayList 还不熟悉,你可以参考它的 API 文档,可以很容易理解在 ArrayList 上执行基本的操作.In this post, I will discuss one of			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/L3rLOaM.html" rel="bookmark" class="title">Linux&sol;yum</a>
					<div>
						作业六:yum命令1) 自定义yum仓库:createrepo[[email protected] /]#mkdir /rpm_bak[[email protected] /]#cp /media/P ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/B0RZEy0.html" rel="bookmark" class="title">dubbo学习 一 dubbo概述</a>
					<div>
						1,背景 1,网站刚开时候的时候可能所有的功能业务都在一个应用里面 2,当业务不断复杂,流量不断增多的时候,就需要将原先的一个应用划分成多个独立的应用. 3,当分出来的业务越来越多的时候,应用也变的多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/7MVaZk4.html" rel="bookmark" class="title">巧用Mysqlbinlog恢复数据库数据</a>
					<div>
						关于binlog的详解请参考:http://zlyang.blog.51cto.com/1196234/1833062 binlog日志用于记录所有更新了数据或者已经潜在更新了数据的所有语句.语句以& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3q5Qez3.html" rel="bookmark" class="title">ogg初始化进程配置</a>
					<div>
						网上搜索&quot;ogg配置&quot;,基本上都是配置流程,较少有ogg初始化进程的技术文档.一般ogg初始化主要分为两种,一种是源数据库表列不含clob类型,另一种 情况是源数据库表列含有clo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JkvrQM.html" rel="bookmark" class="title">C语言例题系列-------第七天</a>
					<div>
						//13.将10个整数数储存在一个数组中,设计一个程序输出这个数组的最大值和最小值 //书上的答案: /*#include&lt;stdio.h&gt; int main() { int max,mi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoYr1P3.html" rel="bookmark" class="title">经典汉诺塔递归实现</a>
					<div>
						/*  * 为了将num个盘子从char移动到to,需要先将第num个盘子上面的num-1个盘子移动到temp上,  * 然后将第num个盘子移动到to上,最后将第N-1个盘子从temp移动到to上. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OaP9GM.html" rel="bookmark" class="title">Spark笔记：复杂RDD的API的理解（上）</a>
					<div>
						本篇接着讲解RDD的API,讲解那些不是很容易理解的API,同时本篇文章还将展示如何将外部的函数引入到RDD的API里使用,最后通过对RDD的API深入学习,我们还讲讲一些和RDD开发相关的scala ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLDBqeM.html" rel="bookmark" class="title">OpenGL ES3&period;0</a>
					<div>
						到今天,喜欢上了非常酷的图片处理和游戏,经了解,大部分都要使用opengl es,所以准备开始学习,然后深入学习cocos2d,GPUImage.平台为IOS OpenGL ES OpenGL ES  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NzWQ24.html" rel="bookmark" class="title">mysql set names&period;</a>
					<div>
						SET NAMES utf8 相当于 SET character_set_client = utf8 --用来设置客户端送给MySQL服务器的数据的 字符集 SET character_set_res ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3O7AEG3.html" rel="bookmark" class="title">hdu Buy the Ticket</a>
					<div>
						1 import java.math.BigInteger; 2 import java.util.*; 3 public class Main { 4 public static void main ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pzPyx0.html" rel="bookmark" class="title">如何在Linux终端里用Shell和C输出带颜色的文字</a>
					<div>
						我们知道,使用ls命令列出文件列表时,不同的文件类型会用不同的颜色显示.那么如何实现这样带颜色的文本输出呢?答案并不复杂,不管是用shell还是C语言. 一.shell下的实现方法 先来讲在shell ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41zRNJM.html" rel="bookmark" class="title">App开发流程之图像处理工具类</a>
					<div>
						先罗列一下工具类中提供的方法: /** * 根据原始view和毛玻璃样式,获取模糊视图,并自动作为原view的subview(如果不需要作为子视图,自行调用removeFromSuperview) * ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k91EE4.html" rel="bookmark" class="title">1&period;cocos2dx 3&period;2环境搭建</a>
					<div>
						1        所需软件 jdk-7u25-windows-i586.exe python-2.7.8.amd64.msi cocos2d-x-3.2.zip apache-ant-1.9.4.zi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nRLaV0.html" rel="bookmark" class="title">来份ASP&period;NET Core尝尝</a>
					<div>
						0x01.前言 学习ASP.NET Core也有一段时间了,虽说很多内容知识点还是处于一知半解的状态,但是基本的,还是 略懂一二.如果有错误,还望见谅. 本文还是和之前一样,Demo+在Linux下运 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41G82G0.html" rel="bookmark" class="title">二分图入门</a>
					<div>
						判断一个图是不是二分图 用染色法,二分图是这样一个图: 有两顶点集且图中每条边的的两个顶点分别位于两个顶点集中,每个顶点集中没有边相连接! 判断二分图的常见方法:开始对任意一未染色的顶点染色,之后判断 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dEYZz3.html" rel="bookmark" class="title">黑白球--智力测验</a>
					<div>
						作者:iamlaosong 一个袋子里有两种颜色的球,黑色和白色,你每次从中取出两个球,如果是同色的,则在袋子里放一个白球,否则放回一个黑球. 最后袋子里剩下一个球,你能最后判断球的颜色么?或者说,你 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pgxkw3.html" rel="bookmark" class="title">华为S5700配置为核心和扩展WAN交换机</a>
					<div>
						目前很多小区ISP或者房东级ISP.中小型的FTTH,很多时候需要用到交换机做路由的扩展WAN,正常的网络部署扩展WAN的交换机和核心交换机是分开的,但无疑成本上也增加了.由于S5700的交换机在性能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nb2vx0.html" rel="bookmark" class="title">软件测试人员需要精通的开发语言（2）</a>
					<div>
						简单的入门语言vbs,通过实例的练习以及简单的应用,基本可以掌握vbs脚本的使用.如果说vbs只是为了实际测试中开发脚本,便捷测试的目的.那SQL语言就是测试人员的必备技能了,任何系统都会用到数据库, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVWEZp0.html" rel="bookmark" class="title">今天看到一个关于黄帝内经的消息&comma;祝华英的消息</a>
					<div>
						很早的时候,就接触到黄帝内经,以及经络方面的知识 ,但是看不懂,初看上去没有条理,没有规律,看到网上的文章都是讲经脉穴位的使用,大体上都是讲如何用,但是一为什么要这么找,没有说清楚,也可以是自己的知识 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLp25kM.html" rel="bookmark" class="title">django 博客搭建</a>
					<div>
						comment1.安装django pip install django 2.创建项目 django-admin startproject mysite 3.在mysite文件夹下创建app pyth ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
